<template>
  <div class="col-xl-3 py-5">
    <div class="sticky-top recap">
      <h3 class="h4 mb-3">Récapitulatif</h3>
      <div class="recap-panel">
        <div class="code-promo">
          <b-alert variant="danger" show v-if="errorCode > 0">{{ messageErrorCode }}</b-alert>
          <div v-if="cartStore.presenceCodePromo">
            Code promo utilisé : <strong>{{ cartStore.libelleCodePromo }}</strong
            ><br /><b-button text="Button" variant="danger" size="sm" @click="removePromo()">Supprimer</b-button>
          </div>
          <b-form v-else>
            <h6 class="mr-sm-3">Code Promo :</h6>
            <b-input-group class="mb-3" placeholder="Entrez votre code promo">
              <b-form-input size="sm" v-model="valueCodePromo"></b-form-input>
              <b-input-group-append>
                <b-button text="Button" variant="success" size="sm" @click="checkCodePromo()">Valider</b-button>
              </b-input-group-append>
            </b-input-group>
          </b-form>
        </div>

        <p>
          <small>Numéro de commande : {{ cartStore.idCart }}</small>
        </p>

        <div class="mb-4">
          <ul class="list-unstyled">
            <li class="recap-caddie__line">
              <span>Article(s) :</span>
              <span>{{ cartStore.nbArticles }}</span>
            </li>

            <li class="recap-caddie__line">
              <span>Total HT :</span>
              <span>{{ cartStore.totalHT | euro }} HT</span>
            </li>

            <li class="recap-caddie__line">
              <span>TVA 20% :</span>
              <span>{{ cartStore.costTVA | euro }}</span>
            </li>

            <li class="recap-caddie__line" v-if="cartStore.delivery.name != ''">
              <span>{{ cartStore.delivery.name }} :</span>
              <span>{{ cartStore.delivery.cost | euro }}</span>
            </li>

            <li class="recap-caddie__line">
              <span>Total TTC :</span>
              <span>{{ cartStore.totalTTC | euro }}</span>
            </li>
          </ul>
        </div>

        <div class="mb-3">
          <b-form-checkbox id="cgv" name="cgv" value="true" unchecked-value="false" class="mb-2" @change="setCgv()" > Je reconnais avoir pris connaissance des <a href="">conditions générales de vente</a> </b-form-checkbox>

          <b-form-checkbox id="confidentialite" name="confidentialite" value="true" unchecked-value="false" class="mb-2" @change="setPolitique()">
            Je reconnais avoir pris connaissance et consent à la <a href="">politique de confidentialité</a>
          </b-form-checkbox>
        </div>

        <b-button block variant="primary" v-if="cartStore.cgv && cartStore.politique">Valider mon panier</b-button>
        <b-button block variant="primary" v-else disabled>Valider mon panier</b-button>

        <b-button block variant="light"><font-awesome-icon icon="angle-right" /> Continuer mes achats</b-button>
      </div>
    </div>
  </div>
</template>
<script>
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_DATAS_ACTIV = URL_API + "api/popups/list/activ/";
const MODULENAME = "codepromo1";
import { mapState, mapActions } from "vuex";
export default {
  computed: {
    // récupération infos client
    ...mapState({
      cartStore: state => state.cartStore
    })
  },
  data() {
    return {
      valueCodePromo: "",
      moduleName: MODULENAME,
      dataList: [],
      contentRaw: [],
      errorCode: 0,
      messageErrorCode: ""
    };
  },
  methods: {
    setPolitique() {
      this.$store.dispatch("setPolitique");
    },
    setCgv() {
      this.$store.dispatch("setCgv");
    },
    checkCodePromo() {
      if (this.valueCodePromo != "") {
        this.errorCode = 0;
        this.$axios
          .post(URL_DATAS_ACTIV + this.moduleName)
          .then(response => {
            this.contentRaw = response.data.data;
            this.structureDataCP();
            let _filterInput = this.dataList.filter(codepromo => {
              return codepromo.data.titre1.toString().toLowerCase() == this.valueCodePromo.toString().toLowerCase();
            });
            // TODO: mettre en place vuelidate
            // vérif si code existe
            if (_filterInput.length <= 0) {
              this.errorCode = 1;
              this.messageErrorCode = "Code promo non valide";
            }
            // on prend le premier résultat trouvé comme ça pas de cumum
            let _infosCodePromo = _filterInput[0];

            // on vérifie le type de code promo pour faire le calcul adequat
            let _montantMini = _infosCodePromo.data.titre3;
            if (_infosCodePromo.data.categorie.toString() == "frais-de-port-offerts") {
              // verif si montant HT supérieur au minimum de commande
              if (parseFloat(_infosCodePromo.data.titre3) > 0 && parseFloat(this.cartStore.totalHT) >= parseFloat(_infosCodePromo.data.titre3)) {
                this.$store.dispatch("setNoFP", { minimumCommande: _montantMini });
              } else if (_infosCodePromo.data.titre3 == "") {
                this.$store.dispatch("setNoFP", { minimumCommande: 0 });
              } else {
                this.errorCode = 1;
                this.messageErrorCode = "Le montant de votre panier n'est pas assez elevé";
              }
            } else {
              let _valueReduc = _infosCodePromo.data.titre2;
              // avec pourcentage
              if (_infosCodePromo.data.switch1 == true) {
                // si montant minimum de commande
                if (_infosCodePromo.data.titre3 != "" && parseFloat(_infosCodePromo.data.titre3) > 0) {
                  if (parseFloat(this.cartStore.totalHT) >= _montantMini) {
                    // j'ajoute dans le store
                    this.$store.dispatch("addCodePromo", { isPourcentage: true, valueReduc: _valueReduc, minimumCommande: _montantMini });
                  } else {
                    this.errorCode = 1;
                    this.messageErrorCode = "Le montant de votre panier n'est pas assez elevé";
                  }
                } else {
                  this.$store.dispatch("addCodePromo", { isPourcentage: true, valueReduc: _valueReduc, minimumCommande: 0 });
                }
              } else {
                // sans pourcentage
                if (_infosCodePromo.data.titre3 != "" && parseFloat(_infosCodePromo.data.titre3) > 0) {
                  if (parseFloat(this.cartStore.totalHT) >= _montantMini) {
                    // j'ajoute dans le store
                    this.$store.dispatch("addCodePromo", { isPourcentage: false, valueReduc: _valueReduc, minimumCommande: _montantMini });
                  } else {
                    this.errorCode = 1;
                    this.messageErrorCode = "Le montant de votre panier n'est pas assez elevé";
                  }
                } else {
                  this.$store.dispatch("addCodePromo", { isPourcentage: true, valueReduc: _valueReduc, minimumCommande: 0 });
                }
              }
            }
          })
          .catch(error => {
            console.log("error", error);
          });
      }
    },
    removePromo() {
      this.$store.dispatch("removeCodePromo");
    },

    structureDataCP() {
      this.dataList = this.contentRaw.filter(mod => {
        let arraySimplePrices = [];
        mod.data = JSON.parse(mod.data);
        return mod;
      });
    }
  }
};
</script>
